using System.Text.Json;
using System.Text.Json.Serialization;
using Amazon.Lambda.Core;

// Assembly attribute to enable the Lambda function's JSON input to be converted into a .NET class.
[assembly: LambdaSerializer(typeof(Amazon.Lambda.Serialization.SystemTextJson.DefaultLambdaJsonSerializer))]
namespace HandlingEnumsInLambdaFunctions;

public class Function
{
    public string FunctionHandler(Stream input, ILambdaContext context)
    {
        var options = new JsonSerializerOptions
        {
            PropertyNameCaseInsensitive = true,
            Converters = { new JsonStringEnumConverter() },
        };

        var car = JsonSerializer.Deserialize<Car>(input, options);
        return car.ToString();
    }
}

public class Car
{
    public string Make { get; set; }
    public string Model { get; set; }
    public int Year { get; set; }
    public Style Style { get; set; }

    public override string ToString()
    {
        return $"Your car is a {Make} {Model} ({Style}), made in {Year}.";
    }
}

public enum Style
{
    Coupe,
    Hatchback,
    Sedan,
    SUV,
    Truck
}
